TetrisShape = {}

TetrisShape.new = function(shapeType)
	return function(template)
		return function(xPos)
			return function(yPos)
				local tShape = Shape.new(shapeType)(template)
				tShape.x = xPos
				tShape.y = yPos
				tShape.render = function(upperBound)
					for y = 1, #tShape.shape do
						for x = 1, #tShape.shape do
							if (tShape.shape[y][x]) then
								if (tShape.y + y - 1 >= upperBound) then
									tShape.shape[y][x].render(Player.GetPlayer("Neutral"))(tShape.x + x - 1)(tShape.y + y - 1)
								else
									if (tShape.shape[y][x].actor) then
										tShape.shape[y][x].derender()
									end
								end
							end
						end
					end
				end
				tShape.moveX = function(offset)
					tShape.x = tShape.x + offset
				end
				tShape.moveY = function(offset)
					tShape.y = tShape.y + offset
				end
				return tShape
			end
		end
	end
end
